--- /tmp/t1	2017-12-20 20:44:26.283462000 +0100
+++ /tmp/t2	2017-12-20 21:06:28.255194000 +0100
@@ -14,15 +14,15 @@
 MPTABLE: warning PCI int dst apic id 255 does not exist
 MPTABLE: warning PCI int dst apic id 255 does not exist
 MPTABLE: warning PCI int dst apic id 255 does not exist
-DragonFly v5.1.0.468.g45d93a-DEVELOPMENT #2: Wed Dec 20 17:49:54 CET 2017
+DragonFly v5.1.0.488.g554f8-DEVELOPMENT #3: Wed Dec 20 20:52:29 CET 2017
     s@hyperv.yo:/usr/obj/home/s/projects/dragonfly/src/sys/HYPERV
 Calibrating clock(s) ...
-TSC clock: 2394675276 Hz (Method A)
-i8254 clock: 1195953 Hz
+TSC clock: 2394626754 Hz (Method A)
+i8254 clock: 1195622 Hz
 hw.calibrate_timers_with_rtc not set - using default i8254 frequency
 hw.calibrate_timers_with_rtc not set - using old calibration method
-TSC clock: 2375688322 Hz
-CPU: Intel(R) Core(TM) i7-5500U CPU @ 2.40GHz (2375.69-MHz K8-class CPU)
+TSC clock: 2375182083 Hz
+CPU: Intel(R) Core(TM) i7-5500U CPU @ 2.40GHz (2375.18-MHz K8-class CPU)
   Origin = "GenuineIntel"  Id = 0x306d4  Stepping = 4
   Features=0x1f83fbff<FPU,VME,DE,PSE,TSC,MSR,PAE,MCE,CX8,APIC,SEP,MTRR,PGE,MCA,CMOV,PAT,PSE36,MMX,FXSR,SSE,SSE2,SS,HTT>
   Features2=0xf6d83203<SSE3,PCLMULQDQ,SSSE3,FMA,CX16,SSE4.1,SSE4.2,MOVBE,POPCNT,AESNI,XSAVE,AVX,F16C,RDRND,VMM>
@@ -44,7 +44,7 @@
 ACPI MADT: cpu id 1, acpi id 2, apic id 1
 ACPI MADT: cpu id 2, acpi id 3, apic id 2
 ACPI MADT: cpu id 3, acpi id 4, apic id 3
-lapic: divisor index 0, frequency 99194110 Hz
+lapic: divisor index 0, frequency 99061575 Hz
 SMP: CPU0 apic_initialize():
      lint0: 0x00000700 lint1: 0x00010400 TPR: 0x00000000 SVR: 0x000001ff
 Bits within APICID: logical_CPU_bits: 0; core_bits: 2
@@ -53,13 +53,13 @@
 MemAffinity 0000000100000000,2176MB Prox=0 CpuApicId 00 Socket 0
 MemAffinity 0000000188200000,58750MB Prox=0 CpuApicId 00 Socket 0
 MemAffinity 0000001000000000,983040MB Prox=0 CpuApicId 00 Socket 0
-SMI Frequency (worst case): 50000 Hz (20 us)
+SMI Frequency (worst case): 20000 Hz (50 us)
 SMP: Waiting APs LAPIC initialization
+SMP: CPU1 apic_initialize():
 SMP: CPU3 apic_initialize():
-SMP: CPU2 apic_initialize():
      lint0: 0x00010000 lint1: 0x00010400 TPR: 0x00000000 SVR: 0x000001ff
-SMP: CPU1 apic_initialize():
      lint0: 0x00010000 lint1: 0x00010400 TPR: 0x00000000 SVR: 0x000001ff
+SMP: CPU2 apic_initialize():
      lint0: 0x00010000 lint1: 0x00010400 TPR: 0x00000000 SVR: 0x000001ff
 ELCR Found.  ISA IRQs programmed as:
   0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
@@ -68,10 +68,10 @@
 objcache: magazine cap [6, 4102]
 Finish MP startup
 Active CPU Mask: 000000000000000f
-Preloaded elf kernel "kernel" at 0xffffffff82c84000.
-Preloaded elf obj module "acpi.ko" at 0xffffffff82c84250.
-Preloaded elf obj module "ehci.ko" at 0xffffffff82c84d28.
-Preloaded elf obj module "xhci.ko" at 0xffffffff82c85640.
+Preloaded elf kernel "kernel" at 0xffffffff82c88000.
+Preloaded elf obj module "acpi.ko" at 0xffffffff82c88250.
+Preloaded elf obj module "ehci.ko" at 0xffffffff82c88d28.
+Preloaded elf obj module "xhci.ko" at 0xffffffff82c89640.
 VMM: VMX is not supported by this Intel CPU
 start dummy scheduler helpers on cpus: 0 1 2 3
 Start usched_bsd4 helpers on cpus:
@@ -289,8 +289,9 @@
 ata0: stat1=0x7f err=0x00 lsb=0x00 msb=0x00
 ata0: stat1=0x7f err=0x00 lsb=0x00 msb=0x00
 ata0: stat1=0x7f err=0x00 lsb=0x00 msb=0x00
-ata0: reset tp2 stat0=50 stat1=ff devices=0x1<ATA_MASTER>
+ata0: reset tp2 stat0=50 stat1=ff devices=0x1
 interrupt uses mplock: ata0
+ata0: identify ch->devices=00000001
 ata0-master: pio=PIO4 wdma=WDMA2 udma=UNSUPPORTED cable=40 wire
 ad0: setting PIO4 on PIIX4 chip
 ad0: setting WDMA2 on PIIX4 chip
@@ -331,11 +332,12 @@
 ata1: stat1=0x7f err=0x00 lsb=0x00 msb=0x00
 ata1: stat1=0x7f err=0x00 lsb=0x00 msb=0x00
 ata1: stat1=0x7f err=0x00 lsb=0x00 msb=0x00
-ata1: reset tp2 stat0=50 stat1=ff devices=0x4<ATAPI_MASTER>
+ata1: reset tp2 stat0=50 stat1=ff devices=0x10000
 interrupt uses mplock: ata1
+ata1: identify ch->devices=00010000
 ata1-master: pio=PIO4 wdma=WDMA2 udma=UNSUPPORTED cable=40 wire
-acd0: setting PIO4 on PIIX4 chip
 ad0: type 0xa5, start 63, end = 266337791, size 266337729 : OK
+acd0: setting PIO4 on PIIX4 chip
 acd0: <Virtual CD/> DVDROM drive at ata1 as master
 acd0:  PIO4
 acd0: Reads: DVDROM
@@ -515,17 +517,17 @@
 cd0: Attempt to query device size failed: NOT READY, Medium not present
 ATA PseudoRAID loaded
 Mounting root from hammer:ad0s1d
-HAMMER(ROOT) recovery check seqno=068400f1
-HAMMER(ROOT) recovery range 30000000174483b8-30000000174483b8
-HAMMER(ROOT) recovery nexto 30000000174483b8 endseqno=068400f2
+HAMMER(ROOT) recovery check seqno=06885406
+HAMMER(ROOT) recovery range 300000001ef44138-300000001ef44138
+HAMMER(ROOT) recovery nexto 300000001ef44138 endseqno=06885407
 HAMMER(ROOT) mounted clean, no recovery needed
 DMA space used: 4136k, remaining available: 131072k
 Mounting devfs
 start_init: trying /sbin/init
-kthread 0xfffff80176ba6e80 syncer6 has exited
-kthread 0xfffff80240ee5880 syncer7 has exited
-kthread 0xfffff80240ee5e00 syncer8 has exited
-kthread 0xfffff80176ba6e80 syncer9 has exited
-kthread 0xfffff80176ba6380 syncer10 has exited
-kthread 0xfffff80240ee5e00 syncer11 has exited
+kthread 0xfffff80176ba6900 syncer6 has exited
+kthread 0xfffff80176b62c80 syncer7 has exited
+kthread 0xfffff80176ba6900 syncer8 has exited
+kthread 0xfffff80176ba6380 syncer9 has exited
+kthread 0xfffff80240ee5880 syncer10 has exited
+kthread 0xfffff80176b62c80 syncer11 has exited
 swap low/high-water marks set to 83883/125825