From root@yoyodyne.ath.cx	Wed Sep 28 20:26:29 2016
Received: from root (uid 0)
	(envelope-from root@yoyodyne.ath.cx)
	id 9cc674437
	by yoyodyne.ath.cx (DragonFly Mail Agent v0.9+);
	Wed, 28 Sep 2016 20:26:28 +0200
From: root (Cron Daemon)
To: root
Subject: Cron <root@yoyodyne> ckstd
X-Cron-Env: <PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/pkg/bin:/usr/pkg/sbin:/usr/local/bin:/home/s/bin>
X-Cron-Env: <SHELL=/bin/sh>
X-Cron-Env: <HOME=/root>
X-Cron-Env: <LOGNAME=root>
X-Cron-Env: <USER=root>
Date: Wed, 28 Sep 2016 20:26:29 +0200
Message-Id: <57ec0b55.9cc674437.52528eb@yoyodyne.ath.cx>
Status: R

UNIX98
==============================
--- /home/s/tmp/ckstd/UNIX98.log	2016-09-28 19:45:55.223939000 +0200
+++ /home/s/tmp/ckstd/UNIX98.log.new	2016-09-28 20:17:32.444011000 +0200
@@ -13330,21 +13330,9 @@
                  ^
     -----------------------------------------------------------------------
 
-  Testing for constant TABDLY... FAIL
-    Constant "TABDLY" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TABDLY' undeclared here (not in a function)
-     __typeof__ (TABDLY) a = TABDLY;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TABDLY... OK
 
-  Testing for constant TAB0... FAIL
-    Constant "TAB0" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TAB0' undeclared here (not in a function)
-     __typeof__ (TAB0) a = TAB0;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TAB0... OK
 
   Testing for constant TAB1... FAIL
     Constant "TAB1" not available.  Compiler message:
@@ -13362,13 +13350,7 @@
                  ^
     -----------------------------------------------------------------------
 
-  Testing for constant TAB3... FAIL
-    Constant "TAB3" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TAB3' undeclared here (not in a function)
-     __typeof__ (TAB3) a = TAB3;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TAB3... OK
 
   Testing for constant BSDLY... FAIL
     Constant "BSDLY" not available.  Compiler message:
@@ -16825,6 +16807,6 @@
 
 ----------------------------------------------------------------------------
   Total number of tests   : 4638
-  Number of failed tests  :  342 (  7%)
+  Number of failed tests  :  339 (  7%)
   Number of xfailed tests :    0 (  0%)
   Number of skipped tests :  104 (  2%)

XOPEN2K
==============================
--- /home/s/tmp/ckstd/XOPEN2K.log	2016-09-28 19:48:50.822094000 +0200
+++ /home/s/tmp/ckstd/XOPEN2K.log.new	2016-09-28 20:20:28.302075000 +0200
@@ -15245,21 +15245,9 @@
                  ^
     -----------------------------------------------------------------------
 
-  Testing for constant TABDLY... FAIL
-    Constant "TABDLY" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TABDLY' undeclared here (not in a function)
-     __typeof__ (TABDLY) a = TABDLY;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TABDLY... OK
 
-  Testing for constant TAB0... FAIL
-    Constant "TAB0" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TAB0' undeclared here (not in a function)
-     __typeof__ (TAB0) a = TAB0;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TAB0... OK
 
   Testing for constant TAB1... FAIL
     Constant "TAB1" not available.  Compiler message:
@@ -15277,13 +15265,7 @@
                  ^
     -----------------------------------------------------------------------
 
-  Testing for constant TAB3... FAIL
-    Constant "TAB3" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TAB3' undeclared here (not in a function)
-     __typeof__ (TAB3) a = TAB3;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TAB3... OK
 
   Testing for constant BSDLY... FAIL
     Constant "BSDLY" not available.  Compiler message:
@@ -19434,6 +19416,6 @@
 
 ----------------------------------------------------------------------------
   Total number of tests   : 6769
-  Number of failed tests  :  281 (  4%)
+  Number of failed tests  :  278 (  4%)
   Number of xfailed tests :    0 (  0%)
   Number of skipped tests :   83 (  1%)

XOPEN2K8
==============================
--- /home/s/tmp/ckstd/XOPEN2K8.log	2016-09-28 19:51:52.170189000 +0200
+++ /home/s/tmp/ckstd/XOPEN2K8.log.new	2016-09-28 20:23:30.360060000 +0200
@@ -15229,21 +15229,9 @@
                  ^
     -----------------------------------------------------------------------
 
-  Testing for constant TABDLY... FAIL
-    Constant "TABDLY" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TABDLY' undeclared here (not in a function)
-     __typeof__ (TABDLY) a = TABDLY;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TABDLY... OK
 
-  Testing for constant TAB0... FAIL
-    Constant "TAB0" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TAB0' undeclared here (not in a function)
-     __typeof__ (TAB0) a = TAB0;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TAB0... OK
 
   Testing for constant TAB1... FAIL
     Constant "TAB1" not available.  Compiler message:
@@ -15261,13 +15249,7 @@
                  ^
     -----------------------------------------------------------------------
 
-  Testing for constant TAB3... FAIL
-    Constant "TAB3" not available.  Compiler message:
-    -----------------------------------------------------------------------
-    /tmp/termios.h-test.c:2:13: error: 'TAB3' undeclared here (not in a function)
-     __typeof__ (TAB3) a = TAB3;
-                 ^
-    -----------------------------------------------------------------------
+  Testing for constant TAB3... OK
 
   Testing for constant BSDLY... FAIL
     Constant "BSDLY" not available.  Compiler message:
@@ -19326,6 +19308,6 @@
 
 ----------------------------------------------------------------------------
   Total number of tests   : 6980
-  Number of failed tests  :  289 (  4%)
+  Number of failed tests  :  286 (  4%)
   Number of xfailed tests :    3 ( <1%)
   Number of skipped tests :   92 (  1%)