diff --git a/sys/dev/drm/i915/i915_gem.c b/sys/dev/drm/i915/i915_gem.c
index f50b284e25..28efb4bf6a 100644
--- a/sys/dev/drm/i915/i915_gem.c
+++ b/sys/dev/drm/i915/i915_gem.c
@@ -707,7 +707,7 @@ i915_gem_pread_ioctl(struct drm_device *dev, void *data,
 		return ret;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
@@ -1064,7 +1064,7 @@ i915_gem_pwrite_ioctl(struct drm_device *dev, void *data,
 		goto put_rpm;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL) {
+	if (&obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
@@ -1601,7 +1601,7 @@ i915_gem_set_domain_ioctl(struct drm_device *dev, void *data,
 		return ret;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
@@ -1649,7 +1649,7 @@ i915_gem_sw_finish_ioctl(struct drm_device *dev, void *data,
 		return ret;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
@@ -2221,7 +2221,7 @@ i915_gem_mmap_gtt(struct drm_file *file,
 		return ret;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
@@ -3303,7 +3303,7 @@ i915_gem_wait_ioctl(struct drm_device *dev, void *data, struct drm_file *file)
 		return ret;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->bo_handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		mutex_unlock(&dev->struct_mutex);
 		return -ENOENT;
 	}
@@ -4097,7 +4097,7 @@ int i915_gem_get_caching_ioctl(struct drm_device *dev, void *data,
 	struct drm_i915_gem_object *obj;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL)
+	if (obj == NULL)
 		return -ENOENT;
 
 	switch (obj->cache_level) {
@@ -4158,7 +4158,7 @@ int i915_gem_set_caching_ioctl(struct drm_device *dev, void *data,
 		goto rpm_put;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
@@ -4528,7 +4528,7 @@ i915_gem_busy_ioctl(struct drm_device *dev, void *data,
 		return ret;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
@@ -4593,7 +4593,7 @@ i915_gem_madvise_ioctl(struct drm_device *dev, void *data,
 		return ret;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file_priv, args->handle));
-	if (&obj->base == NULL) {
+	if (obj == NULL) {
 		ret = -ENOENT;
 		goto unlock;
 	}
diff --git a/sys/dev/drm/i915/i915_gem_tiling.c b/sys/dev/drm/i915/i915_gem_tiling.c
index 981d80c8fc..92b3050378 100644
--- a/sys/dev/drm/i915/i915_gem_tiling.c
+++ b/sys/dev/drm/i915/i915_gem_tiling.c
@@ -166,7 +166,7 @@ i915_gem_set_tiling(struct drm_device *dev, void *data,
 	int ret = 0;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL)
+	if (obj == NULL)
 		return -ENOENT;
 
 	if (!i915_tiling_ok(dev,
@@ -297,7 +297,7 @@ i915_gem_get_tiling(struct drm_device *dev, void *data,
 	struct drm_i915_gem_object *obj;
 
 	obj = to_intel_bo(drm_gem_object_lookup(file, args->handle));
-	if (&obj->base == NULL)
+	if (obj == NULL)
 		return -ENOENT;
 
 	mutex_lock(&dev->struct_mutex);
diff --git a/sys/dev/drm/i915/intel_display.c b/sys/dev/drm/i915/intel_display.c
index d34ea59396..c386751042 100644
--- a/sys/dev/drm/i915/intel_display.c
+++ b/sys/dev/drm/i915/intel_display.c
@@ -14921,7 +14921,7 @@ intel_user_framebuffer_create(struct drm_device *dev,
 	struct drm_mode_fb_cmd2 mode_cmd = *user_mode_cmd;
 
 	obj = to_intel_bo(drm_gem_object_lookup(filp, mode_cmd.handles[0]));
-	if (&obj->base == NULL)
+	if (obj == NULL)
 		return ERR_PTR(-ENOENT);
 
 	fb = intel_framebuffer_create(dev, &mode_cmd, obj);
diff --git a/sys/dev/drm/i915/intel_overlay.c b/sys/dev/drm/i915/intel_overlay.c
index a84bfc5c00..04944dd3d1 100644
--- a/sys/dev/drm/i915/intel_overlay.c
+++ b/sys/dev/drm/i915/intel_overlay.c
@@ -1129,7 +1129,7 @@ int intel_overlay_put_image(struct drm_device *dev, void *data,
 
 	new_bo = to_intel_bo(drm_gem_object_lookup(file_priv,
 						   put_image_rec->bo_handle));
-	if (&new_bo->base == NULL) {
+	if (new_bo == NULL) {
 		ret = -ENOENT;
 		goto out_free;
 	}